#include <ListMgr.h>

pascal void	main(lMessage,lSelect,lRect,lCell,lDataOffset,lDataLen,lHandle)
int			lMessage;
Boolean		lSelect;
Rect			*lRect;
Cell			lCell;
int			lDataOffset,lDataLen;
ListHandle	lHandle;
{
	Handle	thePH;		/* cell data is assumed to be */
	Rect		vRect;		/* PICT resource IDs */
	int		pictID;

	switch (lMessage) {
	  case lInitMsg:
	  	/* called from LNew */
	  	/* nothing in particular needed */
	  	break;

	  case lDrawMsg:
	  	/* called from LClick and LDraw */
	  	if (lDataLen > 0) {
			LGetCell(&pictID,&lDataLen,lCell,lHandle);
			thePH = GetResource('PICT',pictID);
			if (thePH) {
				/* calculate Cell's "full" size */
				vRect.top = lRect->top;
				vRect.left = lRect->left;
				vRect.bottom = lRect->top + (**lHandle).cellSize.v;
				vRect.right = lRect->left + (**lHandle).cellSize.h;

	  			DrawPicture((PicHandle)thePH,&vRect);
	  		}
	  	}
	  	else
	  		EraseRect(lRect);

		/* stop if no selection is needed */
		if (!lSelect)
	  		break;

	  /* otherwise, fall through to... */
	  case lHiliteMsg:
	  	InvertRect(lRect);
	  	break;

	  case lCloseMsg:
	  	/* called from LDispose */
	  	/* nothing in particular needed */
	  	break;
	}
}

