PROGRAM PortInitDemo; 
 
 VAR 
	Event : EventRecord;				{ event record structure instance	} 	whatHappened : EventStuff;		{ event detail structure instance	} 	appleMenu,fileMenu,editMenu : MenuHandle;  { handles for std menus	} 	PortA : SerialPort;				{ two serial port data structures	} 

BEGIN
 	XTCommInit;					{ init Toolbox managers, Extender	} 
	InitSPort(@PortA,'A');

	PortA.baud := baud9600;			{9600 baud transmission rate	}
	PortA.parity := evenparity;			{set character parity to even	}
	PortA.stopbits := stop15;			{set to 1.5 stopbits per character	}
	PortA.databits := data7;			{set to 7 databits per character	}
	SetSPort(@PortA);				{set modem port to above values	}

	PortA.inbufsize := 1024;			{set input buffer to 1024 bytes (1K)	}
	PortA.in := NewPointer(Ord4(1024));	{set address of input buffer	}
	PortA.outbufsize := 0;				{leave output buffer untouched	}
	SetBufSPort(@PortA);			{set modem port to above values	}

	REPEAT
 		REPEAT
			SystemTask;			{ slice of cpu time for DAs	}		UNTIL GetNextEvent(everyEvent,Event);       { until event occurs 	}
 
 		HandleEvent(Event,whatHappened);
 
 	UNTIL ExitRequest(whatHappened); 
	ResetSPort(@PortA);				{ release serial port driver	} 
END. 
