/*                        ssg Commlib - TermDemo							*/
/*                          Aztec C compiler 1.06i							*/
/*                        Lightspeed C compiler 2.01						*/
/*							copyright 1987 by ssg							*/

#include  <extender.h>

EventRecord  		Event;                  		/* event record structure instance	*/
EventStuff   		whatHappened; 	/* event detail structure instance	*/
MenuHandle      	appleMenu,fileMenu,editMenu; /* handles for std menus	*/
SerialPort 		PortA;			/* serial port data structure instance	*/
WindowPtr		wPtr;	
TermData		*termPtr;

main()
{
	XTCommInit();					/* init Toolbox managers, Commlib	*/
	termPtr = CrtTermWindow(NULL);	/* create term window and record	*/
	InitSPort(&PortA,'A');				/* set modem port (A) to defaults	*/

	PortA.baud = baud1200;			/* 1200 baud transmission rate	*/
	PortA.parity = noparity;			/* set character parity to none	*/
	PortA.stopbits = stop20;			/* set to 2 stopbits per character	*/
	PortA.databits = data8;			/* set to 8 databits per character	*/
	SetSPort(&PortA);				/* set modem port to above values	*/

	PortA.inbufsize = 2048;			/* set input buffer to 1024 bytes (1K)	*/
	PortA.in = NewPointer((long)2048);	/* set address of input buffer	*/
	PortA.outbufsize = 0;				/* leave output buffer untouched	*/
	SetBufSPort(&PortA);				/* set modem port to above values	*/

	termPtr->commPort:= &PortA;		/* link term window and modem port	*/
	wPtr = termPtr->commWindow;		/* save term WindowPtr for later use	*/
	ShowWindow(wPtr);				/* make term window visible, active	*/

	do {        
		do {
			CheckPort(termPtr);		/* check for chars arriving at port	*/
			SystemTask();			/* slice of cpu time for DAs	*/  		} while (!GetNextEvent(everyEvent,&Event));     /* until event occurs 	*/

		HandleEvent(&Event,&whatHappened);

	} while (ExitRequest(&whatHappened) == FALSE);
	KillWindow(wPtr);				/* remove window & data structures	*/
	ResetSPort(&PortA);				/* release serial port driver, memory	*/
}
