/*						  Small Systems Guild								*/

/* 				  copyright  1987 Small Systems Guild 						*/
/*					   Lightspeed C compiler 2.01							*/

/*					   private library header file							*/

/*	DAS	02/10/87	Created this file, added SetShell()					0.1	*/
/*	DAF	02/11/87	Added CountWindows(), DoDlog(), ZoomRect(),			0.1	*/
/*					GlobalCellRect(), 										*/
/*	DAF	03/05/87	Added app launch list support routines, structs		0.4	*/
/*	DAF	03/09/87	Added WDPBRec definition, restructured LaunchInfo	0.5	*/

#include	<SegmentLdr.h>
#include	<SSGproto.h>

#define SHELLmaxname	15
#define	APP_ICON_ID		907
#define	MAC_ICON_ID		915

struct	LaunchInfo {
			int			vRefNum;
			long		dirID;
			Handle		iconHndl;
			int			iconID;
			int			aliaID;
			Cell		cell;
		};
typedef	struct	LaunchInfo	LaunchInfo;

struct WDPBRec {	/* File Manager working directory param block struct	*/
			struct WDPBRec *	qLink;
			short				qType;
			short				ioTrap;
			Ptr					ioCmdAddr;
			ProcPtr				ioCompletion;
			short				ioResult;
			char *				ioNamePtr;
			short				ioVRefNum;
			short				filler;
			short				ioWDIndex;
			long				ioWDProcID;
			short				ioWDVRefNum;
			short				filler2[7];
			long				ioWDDirID;
};
typedef struct WDPBRec			WDPBRec;
typedef struct WDPBRec *		WDPBPtr;

pascal void		SFLaunchDefProc();		/* no prototype needed; not directly called */
ListHandle		InitLaunchList();
Boolean			GetLaunchApps();
Boolean			SFGetApp();
Boolean			AddSFLaunchApp();
Boolean			DelSFLaunchApp();
Boolean			DoLaunchWindow();

extern 	WindowPtr 	InsertWindow();
extern	int			CountWindows();
extern	void 		GlobalCellRect();
extern	void 		ZoomRect();
extern	int 		DoDlog();
extern 	Boolean		SetShell();
extern	int 		CountWindows();
