/*							 3105 Sunnywood									*/
/*						Ann Arbor, Michigan 48103							*/
/*							 (313) 996-4238									*/

/* 				  copyright  1987 Small Systems Guild 						*/

/*					  source code compilable using							*/
/*					   Lightspeed C compiler 2.01							*/

#include	<extender.h>

#define		OBJ_SYNC	3047158L			/* object validation constant	*/

			/* type constant declarations for transportability	*/

#define		SHORT		int
#define		USHORT		unsigned int
#define		LONG		long
#define		ULONG		unsigned long
#define		BYTE		char
#define		UBYTE		unsigned char

			/* object type constants for object isa field		*/

#define		UNKNOWN		0

#define		OBJECT		1								/* object instance	*/
#define		WINDOW		11								/* window instance	*/

			/* message selector constants for object methods	*/

#define		NEW			1
#define		SELF		2
#define		CLASS		3
#define		SIZE		4
#define		VALID		5
#define		ASK_STATUS	6
#define		SET_STATUS	7
#define		HIDE		20
#define		SHOW		21
#define		ACTIVATE	22
#define		DEACTIVATE	23
#define		MOVE		24
#define		GROW		25
#define		UPDATE		26

#define		FREE		99

			/* message status constants for object status field	*/

#define		INACTIVE	1
#define		ACTIVE		2
#define		VISIBLE		3
#define		INVISIBLE	4

#define		DAMAGED		99

typedef struct {
			USHORT			isa;
			USHORT			size;
			USHORT			status;
			ULONG			sync;
			Handle			id;
		} object;

typedef struct {
			Handle		objHndl;
			ULONG		objDat1;
			ULONG		objDat2;
			ULONG		objDat3;
			ULONG		objDat4;
		} msgArgs;

typedef struct {
			USHORT			isa;
			USHORT			size;
			USHORT			status;
			ULONG			sync;
			Handle			id;
			WindowPtr		wPtr;
		} window;

Handle 		msg();
Handle 		_msg();
Handle 		class_any_object();

Handle 		Object();
Handle		new_object();
Handle 		class_object();
Handle 		size_object();
Handle		self_object();
Handle 		ask_object();
Handle 		set_object();
Handle 		valid_object();
Handle 		free_object();

Handle 		Window();
Handle		new_window();
WindowPtr	crt_window();
WDHandle 	setup_WData();
Handle		show_window();
Handle 		hide_window();
Handle		show_window();
Handle 		actv_window();
Handle		deactv_window();
Handle		move_window();
Handle		grow_window();
Handle 		updt_window();
Handle 		free_window();
