/*						* Commlib library source *							*/
/*						ssg Commlib 										*/

/*		Copyright  1985,86,87 by small systems guild.  All rights reserved.	*/

/*				Written to compile under Aztec C version 1.06i 				*/
/*					and under Lightspeed C version 2.01						*/

#include  <extender.h>   /* include Commlib and standard Toolbox headers	*/


void StdMenus(appleMenu,fileMenu,editMenu)		/* builds standard menus  	*/
MenuHandle  *appleMenu,*fileMenu,*editMenu;		/* and draws the menu bar 	*/
{
	if (ValidPointer((Ptr)appleMenu)) {
		*appleMenu = NewMenu(APPLEid,"\P\24");
		AppendMenu(*appleMenu,"\P(About...;(-");
		AddResMenu(*appleMenu,'DRVR');
		InsertMenu(*appleMenu,0);
	}
	if (ValidPointer((Ptr)fileMenu)) {
		*fileMenu = NewMenu(FILEid,"\PFile");
		AppendMenu(*fileMenu,"\P(New;(Open...;(-;(Close;(Save;(Save as...;(Revert;(-;(Page Setup...;(Print...;(-;Quit/Q");
		InsertMenu(*fileMenu,0);
	}
	if (ValidPointer((Ptr)editMenu)) {
		*editMenu = NewMenu(EDITid,"\PEdit");
		AppendMenu(*editMenu,"\P(Undo/Z;(-;(Cut/X;(Copy/C;(Paste/V;(Clear;(-;(Show Clipboard;(Select All");
		InsertMenu(*editMenu,0);
	}
	DrawMenuBar();
}

MenuHandle BuildMenu(mNum,title,mItems)         /* adds menu and items to menu linked list  */
int		mNum;
char	*title,*mItems;
{
	MenuHandle  H;

	if (mNum == 0)
		return(NULL);

	H = NewMenu(mNum,title);
	AppendMenu(H,mItems);
	InsertMenu(H,0);
	DrawMenuBar();

    return(H);
}
