/*                       ssg Commlib - PortInitDemo							*/
/*                          Aztec C compiler 1.06i							*/
/*                        Lightspeed C compiler 2.01						*/
/*							copyright 1987 by ssg							*/

#include  <extender.h>

EventRecord  		Event;                  		/* event record structure instance	*/
EventStuff   		whatHappened; 	/* event detail structure instance	*/
MenuHandle      	appleMenu,fileMenu,editMenu; /* handles for std menus	*/
SerialPort 		PortA;			/* serial port data structure instance	*/

main()
{
	XTCommInit();					/* init Toolbox managers, Commlib	*/
	InitSPort(&PortA,'A');				/* set modem port (A) to defaults	*/

	PortA.baud = baud9600;			/* 9600 baud transmission rate	*/
	PortA.parity = evenparity;			/* set character parity to even	*/
	PortA.stopbits = stop15;			/* set to 1.5 stopbits per character	*/
	PortA.databits = data7;			/* set to 7 databits per character	*/
	SetSPort(&PortA);				/* set modem port to above values	*/

	PortA.inbufsize = 1024;			/* set input buffer to 1024 bytes (1K)	*/
	PortA.in = NewPointer((long)1024);	/* set address of input buffer	*/
	PortA.outbufsize = 0;				/* leave output buffer untouched	*/
	SetBufSPort(&PortA);				/* set modem port to above values	*/

	do {        
		do {
			SystemTask();			/* slice of cpu time for DAs	*/  		} while (!GetNextEvent(everyEvent,&Event));     /* until event occurs 	*/

		HandleEvent(&Event,&whatHappened);

	} while (ExitRequest(&whatHappened) == FALSE);
	ResetSPort(&PortA);				/* release serial port driver, memory	*/
}
